//+------------------------------------------------------------------+
//|                                          Visual_OrderSize_EA.mq4 |
//|                                                    Kenny Hubbard |
//|                                       http://www.compu-forex.com |
//+------------------------------------------------------------------+
#property copyright "Kenny Hubbard"
#property link      "http://www.compu-forex.com"

extern double  Risk = 1;
extern string  Note_1 = "0 - Balance/1 - Equity/2 - Free Margin/3 - Fix_Dollars";
extern int     Risk_Basis = 0;
extern double  Fix_Dollars = 0;
 

int
   D_Factor = 1,
   LotDigits = 1;

double
   Pip,
   Stoploss;
string
   Obj_Prefix = "VOE_";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Pip=Point;

   if(Digits==3||Digits==5){D_Factor=10;Pip*=10;}
   if (MarketInfo(Symbol(),MODE_LOTSTEP) == 0.01)LotDigits = 2;
   CreateTextLable(Obj_Prefix+"Risk_Label","Risk % = ",White,1,10);
   CreateTextLable(Obj_Prefix+"Risk_Val",DoubleToStr(Risk,1),White,120,10);
   int handle=FileOpen("Visual_Order_EA_Settings.csv",FILE_CSV|FILE_WRITE,";");
   FileWrite(handle,Risk, Risk_Basis);
   FileClose(handle);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
color
   Text_Color;
double
   Current_SL;
   if(ObjectFind(Obj_Prefix+"SL_Line")==-1)ObjectCreate(Obj_Prefix+"SL_Line",OBJ_HLINE,0,0,Ask);
   Current_SL = ObjectGet(Obj_Prefix+"SL_Line",OBJPROP_PRICE1);
   if(Current_SL>=Bid&&Current_SL<=Ask){
      CreateTextLable(Obj_Prefix+"SL_Label","Stoploss = ",Yellow,1,50);
      CreateTextLable(Obj_Prefix+"Stoploss","N/A",Yellow,120,50);
      CreateTextLable(Obj_Prefix+"Vol_Label","Lots = ",Yellow,1,70);
      CreateTextLable(Obj_Prefix+"Vol","N/A",Yellow,120,70);
      return(0);
   }
   CreateTextLable(Obj_Prefix+"Money_Risk","Cash at risk = $",White,1,30);
   CreateTextLable(Obj_Prefix+"Money_Val",DoubleToStr(Cash_Risk(),2),White,125,30);
   if(Current_SL<Bid){
      Stoploss = (Bid-Current_SL)/Pip;
      Text_Color = LawnGreen;
   }
   if(Current_SL>Ask){
      Stoploss = (Current_SL-Ask)/Pip;
      Text_Color = Red;
   }
   CreateTextLable(Obj_Prefix+"SL_Label","Stoploss = ",Text_Color,1,50);
   CreateTextLable(Obj_Prefix+"Stoploss",DoubleToStr(Stoploss,1),Text_Color,120,50);
   CreateTextLable(Obj_Prefix+"Vol_Label","Lots = ",Text_Color,1,70);
   CreateTextLable(Obj_Prefix+"Vol",DoubleToStr(Get_Lots(Stoploss),LotDigits),Text_Color,120,70);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
void CreateTextLable(string TextLableName,string Text,color l_Text_Color,int X,int Y)
{ 
int
   TextSize = 15,
   Corner = 0;
string
   Font = "Times New Roman";
   ObjectCreate(TextLableName, OBJ_LABEL, 0, TimeCurrent(), 0);
   ObjectSet(TextLableName, OBJPROP_CORNER, Corner);
   ObjectSet(TextLableName, OBJPROP_XDISTANCE, X);
   ObjectSet(TextLableName, OBJPROP_YDISTANCE, Y);
   ObjectSetText(TextLableName,Text,TextSize,Font,l_Text_Color);
}
//+------------------------------------------------------------------+
double Get_Lots(double l_SL)
{
double
   Ret_Lots,
   Money_Loss;
//   l_SL /= Pip;
double
   Pip_Value = MarketInfo(Symbol(),MODE_TICKVALUE) * D_Factor,
   Lot_Value = MarketInfo(Symbol(),MODE_LOTSIZE);
double 
   Money_Per_Tick = (Cash_Risk()/l_SL),
   Trade_Size = Money_Per_Tick/Pip_Value;
   Trade_Size = Trade_Size * 100000/Lot_Value;
   Trade_Size = MathMax(Trade_Size,MarketInfo(Symbol(),MODE_MINLOT));
   Trade_Size = MathMin(Trade_Size,MarketInfo(Symbol(),MODE_MAXLOT));
   return(Trade_Size);
}
//+------------------------------------------------------------------+
double Cash_Risk()
{
double Money_Loss;
   switch(Risk_Basis){
      case 0 : Money_Loss = AccountBalance()*(Risk/100);
               break;
      case 1 : Money_Loss = AccountEquity()*(Risk/100);
               break;
      case 2 : Money_Loss = AccountFreeMargin()*(Risk/100);
               break;
      case 3 : Money_Loss = Fix_Dollars*(Risk/100);
               if(Fix_Dollars==0){
                    Alert(
                        "Fix_Dollars Cannot Be Zero "+
                        "Enter Real Value And Try Again"
                    );
               }
               break;
   }
   return(Money_Loss);
}
//+------------------------------------------------------------------+